package com.mycompany;

import javax.enterprise.context.ApplicationScoped;
import javax.enterprise.inject.Produces;
import org.infinispan.configuration.cache.Configuration;
import org.infinispan.configuration.cache.ConfigurationBuilder;
import org.infinispan.eviction.EvictionStrategy;
import org.infinispan.manager.DefaultCacheManager;
import org.infinispan.manager.EmbeddedCacheManager;
import org.infinispan.transaction.lookup.GenericTransactionManagerLookup;

/**
 *
 * @author gregor
 */
public class Config {
    @Produces
    @ApplicationScoped
    public EmbeddedCacheManager defaultEmbeddedCacheManager() {
        DefaultCacheManager returnCacheManager;

        ConfigurationBuilder builder = new ConfigurationBuilder();
        //builder.eviction().strategy(EvictionStrategy.NONE).maxEntries(Integer.MAX_VALUE).transaction().transactionManagerLookup(new GenericTransactionManagerLookup()).expiration().lifespan(Long.valueOf(-1)).maxIdle(Long.valueOf(-1));
        builder.eviction().strategy(EvictionStrategy.NONE).transaction().transactionManagerLookup(new GenericTransactionManagerLookup()).expiration().lifespan(Long.valueOf(-1)).maxIdle(Long.valueOf(-1));
        Configuration config = builder.build();

        returnCacheManager = new DefaultCacheManager(config);
        String cacheNames[] = new String[2];
        cacheNames[0] = "cache1";
        cacheNames[1] = "cache2";
        returnCacheManager.startCaches(cacheNames);

        return returnCacheManager;
    }
}
